



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【View层】界面绘制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【View层】界面绘制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 02:19:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>【引用】：</strong>http://www.jianshu.com/p/c5fc8c6b967a</p>
<p>【View层】IOS纯代码绘制界面（一）</p>
<div>
<div>字数2303 阅读385 评论2 喜欢16</div>
<div>
<p>IOS开发中界面绘制占据了绝大部分的工作量，当前可以使用StoryBoard，xib以及代码三种方式定制所需要的界面。在这三种方式中代码是最灵活，最具有扩展性的，而特别是多人合作的大项目中StoryBoard，xib不利于代码合并。<br />接下来对之前项目的的界面开发做一些总结。</p>
<ul><li>UIViewController和重要子类</p>
<ul><li>UINavigationController</li></ul></li>
<li>UIView和重要子类
<ul><li>UIControl</li>
<li>UIScrollView</li></ul></li>
<li>各种常用控件的注意点（后续介绍）</li>
<li>应用约束Masonry库（后续介绍）</li>
<li>常用的Code Snippet（后续介绍）</li></ul>
<h2>UIViewController和重要子类</h2>
<p><strong>UINavigationController</strong><br />打交道最多的类无疑是这两个，一般我们采用UINavigationController（导航控制器，navi）作为UIViewController(vc)的容器，最常用的方法是</p>
<pre class="prettyprint linenums"><code>//用指定的vc创建，该vc位于栈底。<br />
-(instancetype)initWithRootViewController:(UIViewController *)rootViewController; 

//向栈里push一个vc，位于栈顶<br />
-(void)pushViewController:(UIViewController *)viewController animated:(BOOL)animated;

//从栈里pop一个vc。<br />
-(nullable UIViewController *)popViewControllerAnimated:(BOOL)animated;</code></pre>
<p>一般app中只需要用到一个navi，在AppDelegate中完成初始化即可，后续的界面迁移都是push和pop。值得注意的是使用了navi之后，每个界面会产生一个navigationBar，即位于界面顶部的导航条。导航条的作用是显示当前的界面title和返回按钮，并支持自己添加需要的辅助功能。在任何vc中可以通过</p>
<p><code>self.navigationController.navigationBar</code>或者<code>self.navigationItem</code></p>
<p>访问这个组件，如设置背景色，添加按钮等：</p>
<pre class="prettyprint linenums"><code>[self.navigationController.navigationBar setTitleTextAttributes:@{NSFontAttributeName : [UIFont systemFontOfSize:19], NSForegroundColorAttributeName : someColor}];<br />
[self.navigationController.navigationBar setBackgroundColor:[UIColor whiteColor]];<br />
UIBarButtonItem  * activityDetail = [[UIBarButtonItem alloc] initWithTitle:@&ldquo;帮助&rdquo; style:UIBarButtonItemStylePlain target:self action:@selector(helpButtonClicked)];<br />
self.navigationItem.rightBarButtonItem = activityDetail;</code></pre>
<h5>UIViewController</h5>
<p>作为视图控制器基类，我们一般在里面添加view代码，显示逻辑，包括按钮事件、代理方法（比如tableView的代理等）。不注意的话vc会变得很大，如果行数过多则不易维护，所以说复杂的页面应该做架构上的区分，如MVVM模式将view，viewModel抽离出来。这里暂不细讲。<br />vc最重要的方法包括：</p>
<p><strong>生命周期相关的方法</strong></p>
<pre class="prettyprint linenums"><code>//重写该方法意味着不加载外部的xib文件，自己绘制界面<br />
-(void)loadView;<br />
-(void)viewDidLoad;<br />
-(void)viewWillAppear:(BOOL)animated;<br />
-(void)viewDidAppear:(BOOL)animated;</code></pre>
<p>以上方法在view加载过程中依次调用。一般在loadView或者viewDidLoad中添加自定义的view，但不能添加过于耗时的操作，以避免界面加载被阻塞导致的卡顿。一般把如网络操作，数据库操作加载viewDidAppear中，界面加载可见之后执行。</p>
<p><strong>UIView和重要子类</strong></p>
<p>UIView</p>
<p>先总结UIView的通用方法和属性，然后介绍常用view控件的使用经验。<br />初始化方法，以一个frame作为参数。</p>
<ul><li>(instancetype)initWithFrame:(CGRect)frame</li></ul>
<p><strong>基本</strong></p>
<ul><li>userInteractionEnabled<br />默认YES，代表是否具有用户可操作性，设为NO时任何手势都不生效。在视图重叠的时候，用户的触摸会到达第一个开启了userInteractionEnabled=YES的视图。这个特性有两种用法：穿透和拦截，前者可以制作透明的不可交互背景，后者可以做比如加载中这种遮罩。</li>
<li>layer<br />UIView内部实现，类型是CALayer，并封装了许多未暴露到UIView中的内容，如cornerRadius属性实现圆角只能调用view.layer.cornerRadius。</li>
<li>tag<br />结合viewWithTag使用，类似于android中的findViewById，类似于JavaScript中的getElementById的用法。但不是全局使用，而是在一个view的子视图中查找目标tag。典型场景如两个控件绑定了一个vc作为delegate，实现的协议中可以通过tag来判断是来自哪个控件的事件。</li></ul>
<p><strong>位置与空间相关：</strong></p>
<ul><li>frame</li>
<li>bounds</li></ul>
<blockquote><p>每个UIView有frame 和bounds两个属性，分别代表相对父容器的矩形和相对本容器的矩形（有点难理解）</p>
<pre class="prettyprint linenums"><code>struct CGRect {<br />
  CGPoint origin;<br />
  CGSize size;<br />
};</code></pre>
<p>bound一般用来修改view的相对位置，类似于css中的相对布局，frame类似绝对布局。如图</p></blockquote>
<div><img referrerpolicy="no-referrer"src="072445bb7a39fa433312522c83012624" /></p>
<div>Paste_Image.png
</div>
</div>
<ul><li>center<br />中心点CGPoint</li>
<li>transform<br />视图的仿射变换，默认是CGAffineTransformIdentity，解释为原始变换，意思就是维持原样。通过修改这个值可以改变view的外观，尤其在动画中常用。</li>
<li>contentScaleFactor<br />缩放比例CGFloat</li>
<li>-sizeThatFits：<br />方法，返回适合其中子类的大小。</li></ul>
<p><strong>view的层次</strong></p>
<ul><li>subviews<br />返回所有的子视图</li>
<li>superview<br />返回父视图</li>
<li>window<br />返回view的window对象</li>
<li>-(void)removeFromSuperview;<br />把自己从父view中删掉</li>
<li>-(void)addSubview:(UIView *)view;<br />添加子view</li>
<li>-(void)bringSubviewToFront:(UIView *)view;<br />把子view拉到最前（重叠的情况下，默认按照添加顺序来一层层盖住之前的view）</li>
<li>-(void)sendSubviewToBack:(UIView *)view;<br />把子view放到最后</li>
<li>-(void)layoutSubviews;<br />override point. called by layoutIfNeeded automatically. As of iOS 6.0, when constraints-based layout is used。该方法的调用时机：<br />addSubview会触发layoutSubviews<br />设置view的Frame会触发layoutSubviews，当然前提是frame的值设置前后发生了变化<br />滚动一个UIScrollView会触发layoutSubviews<br />旋转Screen会触发父UIView上的layoutSubviews事件 -改变一个UIView大小的时候也会触发父UIView上的layoutSubviews事件</li></ul>
<p><strong>view的绘制</strong></p>
<ul><li>(void)drawRect:(CGRect)rect;<br />由setNeedsDisplay来触发调用，可以重写该方法来实现一个自定义view，例如在里面执行</li></ul>
<pre class="prettyprint linenums"><code>- (void)drawRect:(CGRect)rect {<br />
    // Drawing code.<br />
    //获得处理的上下文<br />
    CGContextRef context = UIGraphicsGetCurrentContext();<br />
    //设置线条样式<br />
    CGContextSetLineCap(context, kCGLineCapSquare);<br />
    //设置线条粗细宽度<br />
    CGContextSetLineWidth(context, 1.0);     

    //设置颜色<br />
    CGContextSetRGBStrokeColor(context, 1.0, 0.0, 0.0, 1.0);<br />
    //开始一个起始路径<br />
    CGContextBeginPath(context);<br />
    //起始点设置为(0,0):注意这是上下文对应区域中的相对坐标，<br />
    CGContextMoveToPoint(context, 0, 0);<br />
    //设置下一个坐标点<br />
    CGContextAddLineToPoint(context, 100, 100);<br />
    //设置下一个坐标点<br />
    CGContextAddLineToPoint(context, 0, 150);<br />
    //设置下一个坐标点<br />
    CGContextAddLineToPoint(context, 50, 180);<br />
    //连接上面定义的坐标点<br />
    CGContextStrokePath(context);<br />
 }</code></pre>
<blockquote><p>调用时机drawRect是在Controller.loadView,viewDidLoad 两方法之后掉用的.所以不用担心在控制器中,这些View的drawRect就开始画了.这样可以在控制器中设置一些值给View(如果这些View draw的时候需要用到某些变量值).</p></blockquote>
<ul><li>clipsToBounds<br />默认NO，代表子元素显示时可以超出该view的边界。</li>
<li>backgroundColor<br />背景颜色</li>
<li>alpha<br />透明度，默认为1.0代表不透明，注意当alpha为0时等同于hidden，控件无法接收到点击事件。注意该值会影响子视图的绘制，但子视图的alpha不受影响，子视图绘制时的alpha实际效果等于包含链上的所有alpha之乘积。</li>
<li>opaque<br />不透明，默认为YES</li>
<li>hidden<br />隐藏，默认为NO</li>
<li>contentMode<br />参考UIViewContentMode，有多重展示的模式，如图：</li></ul>
<div><img referrerpolicy="no-referrer"src="525d8908a92ccf3e17c8079881d4a687" /></p>
<div>Paste_Image.png
</div>
</div>
<p><strong>动画相关</strong></p>
<pre class="prettyprint linenums"><code>- +(void)animateWithDuration:(NSTimeInterval)duration delay:(NSTimeInterval)delay options:(UIViewAnimationOptions)options animations:(void (^ )(void))animations completion:(void (^ __nullable)(BOOL finished))completion</code></pre>
<p>方法接受几个参数：duration, delay, options, animations, completion。duration代表执行多久delay代表延迟多少时间开始执行，option参考UIViewAnimationOptions（篇幅过大此处略过），animation和completion各为一个block，代表执行的动画和完成后执行的代码。一段示例代码（慢慢放大后迅速缩小的提示效果）：</p>
<div><img referrerpolicy="no-referrer"src="26242c89cfb2eb116e900ed8d3499a02" /></p>
<div>Paste_Image.png
</div>
</div>
<p>其他方法和该方法类似，实际使用时根据实际情况决定。</p>
<p><strong>手势相关</strong><br />添加和删除手势，不过多介绍。</p>
<ul><li>-(void)addGestureRecognizer:(UIGestureRecognizer*)gestureRecognizer;</li>
<li>-(void)removeGestureRecognizer:(UIGestureRecognizer*)gestureRecognizer;</li></ul>
<h5>UIControl</h5>
<p>子类包括：</p>
<div><img referrerpolicy="no-referrer"src="64de69125cf95d134ea44d57f9468614" /></p>
<div>Paste_Image.png
</div>
</div>
<p>其中UIButton和UITextField，UISwitch都是平时十分常用的控件，作为他们的基类有必要介绍一下。</p>
<p><strong>重要的属性与方法：</strong></p>
<ul><li>enabled<br />是否激活，默认YES，设为NO在视觉上会变为灰色</li>
<li>selected<br />是否选中，默认NO，参考UIControlState</li>
<li>highlighted<br />是否highlighted，默认NO，参考UIControlState</li>
<li>state<br />UIControlState类型</li></ul>
<blockquote><p><em>UIControl 基本的 State 变化过程如下</em><br /><em>1.什么都没干的时候：Normal</em><br /><em>2.当你的手指按下去，还没放的时候：Highlighted</em><br /><em>3.当手指放开的时候：如果这个 UIControl 有 Selected 状态的话，就会变成: Selected</em><br /><em>再重复上述过程一次，就会从 Selected-&gt;Highlighted-&gt; Normal</em><br /><em>但是普通的 UIButton 这个 UIControl 的 subclass，是没有 Selected 状态的，它就只有 Normal 和 Highlighted，只会在这两个状态间切换。（正常情况下，如果你设置了 disable 的话，还会变到 Disabled）</em></p></blockquote>
<p><strong>按钮事件</strong></p>
<pre class="prettyprint linenums"><code>- (void)addTarget:(nullable id)target action:(SEL)action forControlEvents:(UIControlEvents)controlEvents;</code></pre>
<p>普通的按钮通过该方法绑定事件即可，其中sel是一个方法指针，UIControlEvents定义了可发送事件的几种类型。按钮点击一般使用UIControlEventTouchUpInside。代表在控件范围内按下去并放开。其余的属性可参考UIControlEvents。</p>
<p><strong>自定义事件实现</strong></p>
<pre class="prettyprint linenums"><code>- (BOOL)beginTrackingWithTouch:(UITouch *)touch withEvent:(nullable UIEvent *)event;<br />
- (BOOL)continueTrackingWithTouch:(UITouch *)touch withEvent:(nullable UIEvent *)event;<br />
- (void)endTrackingWithTouch:(nullable UITouch *)touch withEvent:(nullable UIEvent *)event;</code></pre>
<p>通过以上三个方法可以实现自定义的控件，比如要自己实现滑块效果，先调用begin，然后在continue中利用touch.locationInView的值来改变滑块代表的数值，在end中完成网络，数据库等操作。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93ny4wq.html">Markdown中插入数学公式的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvr5ry8.html">MySQL数据库7 - 汇总和分组数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/r934p1g8.html">Xcode常用的快捷键有哪些？</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2royv9.html">lua 循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1my0k9.html">namespace的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xm03e8.html">xsheell的下载安装初级使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvzpkxq.html">POJ1463 Strategic game &lpar;最小点覆盖 or 树dp&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xg62z9.html">Cgroups概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wyzkoq.html">jqgrid 中设置列不排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e172dj9.html">kill -9杀掉nginx主进程、reload失败解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmvgd79.html">stl中的空间配置器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memrwrq.html">python文件I&sol;O</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1rjgyq.html">tomcat类加载体系</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwo5k9.html">salesforce零基础学习（八十）使用autoComplete 输入内容自动联想结果以及去重实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pro0y8.html">19&period;最省钱的app发短信方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj6rkk9.html">2&period;Git配置和关联GitHub</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk172v8.html">MySQL&sol;ＭariaDB数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vk5v2q.html">SATA工作模式咋选？揭秘AHCI和IDE区别（全文）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p5y60q.html">FreeRTOS基础篇教程目录汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvey4mj9.html">验证是否是正整数，是否是mail，是否是正确的身份证</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8med70oq.html">IDL 计算TVDI</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzeoze8.html">hashmap源码</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yjzwz8.html">Android Studio 简单介绍和使用问题小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkl7d08.html">input text设置字体</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy12m2jq.html">Delphi版IP地址与整型互转</a>
			</li>
						<li><a href="https://www.batexi.com/a/950p4w08.html">Java socket通信</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z7pzj9.html">VS2005混合编译ARM汇编代码-转</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey5ymk9.html">ural1671 Anansi&amp;&num;39&semi;s Cobweb</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey5ykm9.html">计算机学院大学生程序设计竞赛（2015&rsquo;12） 1008 Study Words</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mjrrn8.html">Linux的iptables常用配置范例（2）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
